unit Unit1;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label2: TLabel;
    Label1: TLabel;
    Memo1: TMemo;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TMClick1stClick(Sender: TObject);
    procedure TMClick2ndClick(Sender: TObject);
    procedure TMClick3rdClick(Sender: TObject);
    procedure TMClickSingleClick(Sender: TObject);
    procedure TMClickDoubleClick(Sender: TObject);
    procedure TMClickTripleClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
uses TMClickMemo,
  TMClickEdit,
  TMClickCheckBox,
  TMClickLabel,
  TMClickImage,
  TMClickPanel;

var
  TMClickMemo1: TTMClickMemo;
  TMClickEdit1: TTMClickEdit;
  TMClickCheckBox1: TTMClickCheckBox;
  TMClickLabel1: TTMClickLabel;
  TMClickImage1: TTMClickImage;
  TMClickPanel1: TTMClickPanel;

procedure TForm1.FormCreate(Sender: TObject);
begin
Label3.visible:= false;
  TMClickMemo1 := TTMClickMemo.Create(Self);
  TMClickMemo1.SetBounds(16,40,250,57);
  with TMClickMemo1 do Begin
    Parent := Self;
    On1stClick :=  TMClick1stClick;
    On2ndClick :=  TMClick2ndClick;
    On3rdClick :=  TMClick3rdClick;
    OnSingleClick :=  TMClickSingleClick;
    OnDoubleClick :=  TMClickDoubleClick;
    OnTripleClick :=  TMClickTripleClick;
  End;

  TMClickEdit1 := TTMClickEdit.Create(Self);
  TMClickEdit1.SetBounds(16,110,250,21);
  with TMClickEdit1 do Begin
    Parent := Self;
    On1stClick :=  TMClick1stClick;
    On2ndClick :=  TMClick2ndClick;
    On3rdClick :=  TMClick3rdClick;
    OnSingleClick :=  TMClickSingleClick;
    OnDoubleClick :=  TMClickDoubleClick;
    OnTripleClick :=  TMClickTripleClick;
  End;


  TMClickLabel1 := TTMClickLabel.Create(Self);
  TMClickLabel1.SetBounds(16,145,91,21);
  with TMClickLabel1 do Begin
    Parent := Self;
    On1stClick :=  TMClick1stClick;
    On2ndClick :=  TMClick2ndClick;
    On3rdClick :=  TMClick3rdClick;
    OnSingleClick :=  TMClickSingleClick;
    OnDoubleClick :=  TMClickDoubleClick;
    OnTripleClick :=  TMClickTripleClick;
  End;


  TMClickCheckBox1 := TTMClickCheckBox.Create(Self);
  TMClickCheckBox1.SetBounds(152,143,121,21);
  with TMClickCheckBox1 do Begin
    Parent := Self;
    On1stClick :=  TMClick1stClick;
    On2ndClick :=  TMClick2ndClick;
    On3rdClick :=  TMClick3rdClick;
    OnSingleClick :=  TMClickSingleClick;
    OnDoubleClick :=  TMClickDoubleClick;
    OnTripleClick :=  TMClickTripleClick;
  End;


  TMClickImage1 := TTMClickImage.Create(Self);
  TMClickImage1.SetBounds(16,168,250,100);
  with TMClickImage1 do Begin
    Parent := Self;
    On1stClick :=  TMClick1stClick;
    On2ndClick :=  TMClick2ndClick;
    On3rdClick :=  TMClick3rdClick;
    OnSingleClick :=  TMClickSingleClick;
    OnDoubleClick :=  TMClickDoubleClick;
    OnTripleClick :=  TMClickTripleClick;
    Picture.LoadFromFile('.\demo123.bmp');
  End;

  TMClickPanel1 := TTMClickPanel.Create(Self);
  TMClickPanel1.SetBounds(16,281,250,55);
  with TMClickPanel1 do Begin
    Parent := Self;
    On1stClick :=  TMClick1stClick;
    On2ndClick :=  TMClick2ndClick;
    On3rdClick :=  TMClick3rdClick;
    OnSingleClick :=  TMClickSingleClick;
    OnDoubleClick :=  TMClickDoubleClick;
    OnTripleClick :=  TMClickTripleClick;
  End;


end;

procedure TForm1.TMClick1stClick(Sender: TObject);
begin
  Memo1.Lines.Add(TComponent(Sender).Classname + ' 1stClick ' + IntToStr(TMClickMemo1.CaretPos.X) + ' ' + IntToStr(TMClickMemo1.CaretPos.Y));
end;

procedure TForm1.TMClick2ndClick(Sender: TObject);
begin
  Memo1.Lines.Add(TComponent(Sender).Classname + ' 2ndClick ' + IntToStr(TMClickMemo1.CaretPos.X) + ' ' + IntToStr(TMClickMemo1.CaretPos.Y));
end;

procedure TForm1.TMClick3rdClick(Sender: TObject);
begin
  Memo1.Lines.Add(TComponent(Sender).Classname + ' 3rdClick ' + IntToStr(TMClickMemo1.CaretPos.X) + ' ' + IntToStr(TMClickMemo1.CaretPos.Y));
end;

procedure TForm1.TMClickSingleClick(Sender: TObject);
begin
  Memo1.Lines.Add(TComponent(Sender).Classname + '       SingleClick');
end;

procedure TForm1.TMClickDoubleClick(Sender: TObject);
begin
  Memo1.Lines.Add(TComponent(Sender).Classname + '        DoubleClick');
end;

procedure TForm1.TMClickTripleClick(Sender: TObject);
begin
  Memo1.Lines.Add(TComponent(Sender).Classname + '        TripleClick');
end;

end.

